// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.

package implments

import (
	"LAPP_ACURA_MOM_BACKEND/grmi"
	meta "LAPP_ACURA_MOM_BACKEND/meta/me"
	model "LAPP_ACURA_MOM_BACKEND/models/me"
	"fmt"
	"github.com/go-xorm/xorm"
	"xorm.io/core"
)

/******************************************************************************
 *
 * @Struct Name              : ProductWorkLineLstDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : ProductWorkLineLst的数据访问对象实现
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-10-28 13:12:09
 *
 ******************************************************************************/
type ProductWorkLineLstDAOImplement struct {
	session *xorm.Session
	meta    *grmi.Entity
	plantNr int
	userid  string
}

/******************************************************************************
 *
 * @Function Name            : NewProductWorkLineLstDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : 创建一个ProductWorkLineLstDAOImplement实例
 *
 * @Function Parameters      : xorm会话
 *
 * @Function Parameters      : 基本主键
 *
 * @Return Value             : ProductWorkLineLstDAOImplement实例
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-10-28 13:12:09
 *
 ******************************************************************************/
func NewProductWorkLineLstDAOImplement(session *xorm.Session, plantNr int, userid string) *ProductWorkLineLstDAOImplement {
	return &ProductWorkLineLstDAOImplement{session, &meta.ProductWorkLineLst, plantNr, userid}
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/me/ProductWorkLineLstDAO.InsertOne
 *
 ******************************************************************************/
func (impl *ProductWorkLineLstDAOImplement) InsertOne(entity *model.ProductWorkLineLst) error {
	entity.PlantNr = impl.plantNr
	entity.LastUser = impl.userid
	_, err := impl.session.Table(impl.meta.TableName).Insert(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/me/ProductWorkLineLstDAO.DeleteOne
 *
 ******************************************************************************/
func (impl *ProductWorkLineLstDAOImplement) DeleteOne(productId string, workLineId string) error {
	_, err := impl.session.Table(impl.meta.TableName).ID(core.PK{impl.plantNr, productId, workLineId}).Delete(impl.meta.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}

	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/me/ProductWorkLineLstDAO.SelectOne
 *
 ******************************************************************************/
func (impl *ProductWorkLineLstDAOImplement) SelectOne(productId string, workLineId string) (*model.ProductWorkLineLst, error) {
	var data model.ProductWorkLineLst
	ok, err := impl.session.Table(impl.meta.TableName).ID(core.PK{impl.plantNr, productId, workLineId}).Get(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	if !ok {
		return nil, nil
	}
	return &data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/me/ProductWorkLineLstDAO.UpdateOne
 *
 ******************************************************************************/
func (impl *ProductWorkLineLstDAOImplement) UpdateOne(entity *model.ProductWorkLineLst) error {
	entity.PlantNr = impl.plantNr
	entity.LastUser = impl.userid
	_, err := impl.session.Table(impl.meta.TableName).Cols(impl.meta.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/me/ProductWorkLineLstDAO.Insert
 *
 ******************************************************************************/
func (impl *ProductWorkLineLstDAOImplement) Insert(entities *[]model.ProductWorkLineLst) error {
	for i := 0; i < len(*entities); i++ {
		entity := &(*entities)[i]
		entity.PlantNr = impl.plantNr
		entity.LastUser = impl.userid
	}
	_, err := impl.session.Table(impl.meta.TableName).Insert(entities)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/me/ProductWorkLineLstDAO.Delete
 *
 ******************************************************************************/
func (impl *ProductWorkLineLstDAOImplement) Delete(entities *[]model.ProductWorkLineLst) error {
	for _, entity := range *entities {
		entity.PlantNr = impl.plantNr
		_, err := impl.session.Table(impl.meta.TableName).ID(entity.GetKey()).Delete(impl.meta.Indicator)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/me/ProductWorkLineLstDAO.DeleteWhere
 *
 ******************************************************************************/
func (impl *ProductWorkLineLstDAOImplement) DeleteWhere(predicates []grmi.Predicate) error {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.ProductWorkLineLst_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	_, err := session.Delete(impl.meta.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/me/ProductWorkLineLstDAO.Select
 *
 ******************************************************************************/
func (impl *ProductWorkLineLstDAOImplement) Select(predicates []grmi.Predicate, orderByFields []grmi.Field) ([]model.ProductWorkLineLst, error) {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.ProductWorkLineLst_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	session = session.OrderBy(meta.ProductWorkLineLst_PlantNr.ColumnName)
	if orderByFields != nil {
		for _, field := range orderByFields {
			session = session.OrderBy(field.ColumnName)
		}
	}

	data := make([]model.ProductWorkLineLst, 0, 10)
	err := session.Find(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	return data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/me/ProductWorkLineLstDAO.SelectAndPaging
 *
 ******************************************************************************/
func (impl *ProductWorkLineLstDAOImplement) SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error) {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.ProductWorkLineLst_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	count, err := session.Count(impl.meta.Indicator)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}

	orderBy := " order by " + meta.ProductWorkLineLst_PlantNr.ColumnName
	if orderByFields != nil {
		for _, field := range orderByFields {
			if orderBy == " order by " {
				orderBy += field.ColumnName
			} else {
				orderBy += ", " + field.ColumnName
			}
		}
	}
	parameters = append(parameters, paging.Offset(), paging.Size)
	data := make([]model.ProductWorkLineLst, 0, 10)
	where = " where " + where
	err = impl.session.Table(impl.meta.TableName).SQL("select * from ["+impl.meta.TableName+"]"+where+orderBy+" offset ? row fetch next ? row only", parameters...).Find(&data)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}
	return grmi.PagingResult{Records: data, Count: count, PageNumber: paging.Number, PageSize: paging.Size}, nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/me/ProductWorkLineLstDAO.Update
 *
 ******************************************************************************/
func (impl *ProductWorkLineLstDAOImplement) Update(entities *[]model.ProductWorkLineLst) error {
	for i := 0; i < len(*entities); i++ {
		entity := &(*entities)[i]
		entity.PlantNr = impl.plantNr
		entity.LastUser = impl.userid
		_, err := impl.session.Table(impl.meta.TableName).Cols(impl.meta.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/me/ProductWorkLineLstDAO.UpdateWhere
 *
 ******************************************************************************/
func (impl *ProductWorkLineLstDAOImplement) UpdateWhere(predicates []grmi.Predicate, entity *model.ProductWorkLineLst, columns ...string) error {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.ProductWorkLineLst_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	columns = append(columns, meta.ProductWorkLineLst_LastUser.Name)
	entity.LastUser = impl.userid
	_, err := session.Cols(columns...).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/me/ProductWorkLineLstDAOImplement.SelectByRelate
 *
 ******************************************************************************/
func (impl *ProductWorkLineLstDAOImplement) SelectByRelate(workLineId string) ([]model.Product, error) {
	result := make([]model.Product, 0)
	condition := fmt.Sprintf("%s = %s and %s = %s and %s = %s",
		meta.Product_PlantNr.ColumnName,
		meta.ProductWorkLineLst_PlantNr.ColumnName,
		meta.Product_ProductId.ColumnName,
		meta.ProductWorkLineLst_ProductId.ColumnName,
		meta.Product_ProjectId.ColumnName,
		meta.ProductWorkLineLst_ProjectId.ColumnName)
	session := impl.session.Table(impl.meta.TableName).Join("LEFT", meta.Product.TableName, condition)
	parameters := []interface{}{impl.plantNr, workLineId, true}
	where := fmt.Sprintf("%s = ? and %s = ? and %s = ?",
		meta.ProductWorkLineLst_PlantNr.ColumnName,
		meta.ProductWorkLineLst_WorkLineId.ColumnName,
		meta.Product_MultiWorkLineToggle.ColumnName)
	err := session.Where(where, parameters...).OrderBy(meta.ProductWorkLineLst_ProductId.ColumnName).Find(&result)
	return result, err
}